<form
    autocomplete="off"
    #f="ngForm"
    (ngSubmit)="submit(f)"
>
    <div
        ngModelGroup="contact"
        #contact="ngModelGroup"
    >
        <div *ngIf="!contact.valid">...</div>
        <div class="form-group">
            <label for="firstName">First Name</label>
            <input
                required
                minlength="3"
                maxlength="10"
                pattern="banana"
                ngModel
                name="firstName"
                #firstName="ngModel"
                id="firstName"
                type="text"
                class="form-control"
                (change)="log(firstName)"
            >
            <div
                class="alert alert-danger"
                *ngIf="firstName.touched && !firstName.valid"
            >
                <div *ngIf="firstName.errors.required">First name is required</div>
                <div *ngIf="firstName.errors.minlength">
                    First should be minimum {{firstName.errors.minlength.requiredLength}} characters.
                </div>
                <div *ngIf="firstName.errors.pattern">First does not match the pattern.</div>
            </div>
        </div>
    </div>

    <div class="form-group">
        <label for="comment">Comment</label>
        <textarea
            ngModel
            name="comment"
            id="comment"
            class="form-control"
        ></textarea>
    </div>
    <button class="btn btn-primary">Submit</button>
</form>
